{
   TCanvas *c1 = new TCanvas("c1", "c1",9,31,699,550);
   gStyle->SetOptStat(0);
   c1->ToggleEventStatus();
   //c1->Range(347.5,-0.8764369,1074.664,5.646552);
   c1->SetBorderSize(2);
   c1->SetBottomMargin(0.1343612);
   c1->SetLogy();
   c1->SetGridx();
   c1->SetGridy();

   //TH2D frame("h","",10,0.,10.,10,1.e-4,4000.);
   TH2D frame("h","",10,0.,1.,10,1.e-4,4000.);
   frame.SetStats(0);
   frame.Draw();
   frame.GetXaxis()->SetTitle("#sqrt{s} [TeV]");
   frame.GetXaxis()->SetLabelSize(0.05);
   frame.GetXaxis()->SetTitleSize(0.06);
   frame.GetYaxis()->SetTitle("#sigma [fb]");
   frame.GetYaxis()->SetLabelSize(0.05);
   frame.GetYaxis()->SetTitleSize(0.06);
   frame.GetYaxis()->SetTitleOffset(0.77);
   frame.Draw("");

   double x[1000], y[1000], dy[1000];
   int npt = 0;
   ifstream in("xsection.tt.dat");
   while ((in >> x[npt] >> y[npt] >> dy[npt])) {
	   x[npt] *= 1.e-3;
	   npt++;
   }
   TGraph gr(npt, x, y);
   gr.Draw("c same");

   stringstream stext;
   stext << "t#bar{t}" << ends;
   //TLatex *pt = new TLatex(x[npt-4], 0.3*y[npt-5], stext.str().data());
   TLatex *pt = new TLatex(x[15], 4.3*y[15], stext.str().data());
   pt->SetTextFont(132);
   stext.str("");
   stext.clear();
   pt->Draw();

   npt = 0;
   ifstream in2("xsection.tth.dat");
   while ((in2 >> x[npt] >> y[npt] >> dy[npt])) {
	   x[npt] *= 1.e-3;
	   npt++;
   }
   TGraph gr2(npt, x, y);
   gr2.Draw("c same");

   stext << "t#bar{t}h" << ends;
   //pt = new TLatex(x[npt-4], 0.3*y[npt-5], stext.str().data());
   pt = new TLatex(x[2], 0.3*y[2], stext.str().data());
   pt->SetTextFont(132);
   stext.str("");
   stext.clear();
   pt->Draw();

   npt = 0;
   ifstream in3("xsection.ttz.dat");
   while ((in3 >> x[npt] >> y[npt] >> dy[npt])) {
	   x[npt] *= 1.e-3;
	   npt++;
   }
   TGraph gr3(npt, x, y);
   gr3.Draw("c same");

   stext << "t#bar{t}Z" << ends;
   //pt = new TLatex(x[npt-4], 0.3*y[npt-5], stext.str().data());
   pt = new TLatex(x[10], 2.3*y[10], stext.str().data());
   pt->SetTextFont(132);
   stext.str("");
   stext.clear();
   pt->Draw();

   npt = 0;
   ifstream in4("xsection.nntt.dat");
   while ((in4 >> x[npt] >> y[npt] >> dy[npt])) {
	   x[npt] *= 1.e-3;
	   npt++;
   }
   TGraph gr4(npt, x, y);
   gr4.Draw("c same");

   stext << "#nu#bar{#nu}t#bar{t}" << ends;
   //pt = new TLatex(x[npt-4], 0.3*y[npt-5], stext.str().data());
   pt = new TLatex(x[8], 0.3*y[8], stext.str().data());
   pt->SetTextFont(132);
   stext.str("");
   stext.clear();
   pt->Draw();

   npt = 0;
   ifstream in5("xsection.eett.dat");
   while ((in5 >> x[npt] >> y[npt] >> dy[npt])) {
	   x[npt] *= 1.e-3;
	   npt++;
   }
   TGraph gr5(npt, x, y);
   gr5.Draw("c same");

   stext << "e^{+}e^{-}t#bar{t}" << ends;
   //pt = new TLatex(x[npt-4], 0.3*y[npt-5], stext.str().data());
   pt = new TLatex(0.75*x[1], 1.5*y[1], stext.str().data());
   pt->SetTextFont(132);
   stext.str("");
   stext.clear();
   pt->Draw();
}
