void xsection(Double_t rsi,
              Double_t pole=-1.,
#if 0
              Double_t qzlo=-1.,
              Double_t qzhi=-1.)
#else
              Double_t mzw=40.)
#endif
{
// Macro example for bases calculation.
  gROOT->Reset();
  TFile file("bases.root","RECREATE");

  jsf = new JSFSteer();    // required to read parameter from jsf.conf
  
  bases = new AZBases();
  bases->SetEcmInit(rsi);
  bases->SetPole(pole);
  double mz   = 91.188;
  double qzlo = mz - mzw;
  double qzhi = mz + mzw;
  bases->SetQZLo(qzlo);
  bases->SetQZHi(qzhi);

//  bases->SetNoOfSample(10000);
//  bases->SetIteration1( 0.2, 10);
//  bases->SetIteration2( 0.1, 10);
  bases->Bases();
  bases->Bh_plot();
  bases->Userout();
  bases->Write();
#if 1
  Double_t rs  = bases->GetEcmInit();
  Double_t pe  = bases->GetPole();
  Double_t ql  = bases->GetQZLo();
  Double_t qh  = bases->GetQZHi();
  Double_t sg  = bases->GetEstimate();
  Double_t dsg = bases->GetError();

  stringstream ofname;
  ofname << "xsection.az.pole" << showpos << pe << ".dat" << ends;
  cerr << "ofname = " << ofname.str() << endl;
  ofstream outf(ofname.str().data(),std::ios::app);
  outf << rs << " " << showpos << pe << resetiosflags(ios_base::showpos) << " " << ql << " " << qh<< " " << sg << " " << dsg << endl;
#endif

  file.Write();
}
