//void PlotZ0(const Char_t *fname = "jsf.pfoanl.zpole.thin.hitmerge.sub2ndary.4k.lockalld.emwithe+e-.ev.root")
//void PlotZ0(const Char_t *fname = "jsf.pfoanl.zpole.thin.hitmerge.subonlyn.4k.lockalld.emwithe+e-.ev.root")
//void PlotZ0(const Char_t *fname = "jsf.pfoanl.zpole.thin.hitmerge.subonlyn.4k.lockalld.emwithe+e-.ev.kmassfixed.v0.fixedjsfvertexing.root")
void PlotZ0(const Char_t *fname = "jsf.pfoanl.zpole.noir.nobd.10kev.newcalib.root")
{
  // ------------------------------------------------------------
  //  Open shared libraries
  // ------------------------------------------------------------
  gSystem->Load("libJSF.so");
  gSystem->Load("libS4Utils.so");
  gSystem->Load("libAnlib.so");

  // ------------------------------------------------------------
  //  Open event file and apply cuts
  // ------------------------------------------------------------
  TFile *filep = TFile::Open(fname);
  TNtupleD *tupep = (TNtupleD *)gROOT->FindObject("hevt");

  // Cuts
  Double_t xNpj  = 5.0;
  //Double_t xNpj  = 10.0;
  Double_t xCosj = 0.8;
#if 0
  // Standard cuts
  tupep->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.8&&abs(cosj2)<0.8&&mass>70&&mass<110","goff");
#else
  // No cut
  //tupep->Draw(">>elist","npj1>=0&&npj2>=0&&abs(cosj1)<1.&&abs(cosj2)<1.&&mass>70&&mass<110","goff");
  tupep->Draw(">>elist","npj1>=0&&npj2>=0&&abs(cosj1)<1.&&abs(cosj2)<1.","goff");
#endif
  TEventList *elistp = (TEventList *)gROOT->FindObject("elist");

  const Double_t kNsig = 2.;	// fit range for gaussian fit in units of sigma

  // ------------------------------------------------------------
  //  Define histograms
  // ------------------------------------------------------------
  TH1D *hEvisp    = new TH1D("hEvis"   , "", 80, 70.,110.);
  TH2D *hPtPlp    = new TH2D("hPtPl"   , "", 40,  0., 20.,
                                             80,-20., 20.);
  TH1D *hNpjp     = new TH1D("hNpJ"    , "", 70,  0., 70.);
  TH1D *hCosjp    = new TH1D("hCosJ"   , "",100, -1.,  1.);
  TH1D *hEtotp    = new TH1D("hEtot"   , "", 80, 70.,110.);
  TH1D *hMassp    = new TH1D("hMass"   , "", 80, 70.,110.);

  // ------------------------------------------------------------
  //  Loop over selected events and fill up histograms
  // ------------------------------------------------------------
#if 0
  Int_t nevt = elistp->GetN();
  cerr << "Nevt = " << nevt << endl;

  for (Int_t i=0; i<nevt; i++) {
    Int_t ievt = elistp->GetEntry(i);	// get event number
#else
  ifstream fevlist("fevlist");
  Int_t nevt;
  fevlist >> nevt;
  cerr << "Nevt = " << nevt << endl;
  //Long64_t *evlist = new Long64_t[nevt];
  Int_t *evlist = new Int_t[nevt];
  for (Int_t i=0; i<nevt; i++) {
    fevlist >> evlist[i];
  }

  for (Int_t i=0; i<nevt; i++) {
    Int_t ievt = evlist[i];
#endif

    Double_t npj1, npj2, cosj1, cosj2, evis, pt, pl, mass;
    Double_t etk, eem, ehd, etkpbp, eempbp, ehdpbp, eah;

    tupep->SetBranchAddress("npj1",&npj1);
    tupep->SetBranchAddress("npj2",&npj2);
    tupep->SetBranchAddress("cosj1",&cosj1);
    tupep->SetBranchAddress("cosj2",&cosj2);
    tupep->SetBranchAddress("evis",&evis);
    tupep->SetBranchAddress("pt",&pt);
    tupep->SetBranchAddress("pl",&pl);
    tupep->SetBranchAddress("mass",&mass);
    tupep->SetBranchAddress("etk",&etk);
    tupep->SetBranchAddress("eem",&eem);
    tupep->SetBranchAddress("ehd",&ehd);
    tupep->SetBranchAddress("etkpbp",&etkpbp);
    tupep->SetBranchAddress("eempbp",&eempbp);
    tupep->SetBranchAddress("ehdpbp",&ehdpbp);
    tupep->SetBranchAddress("eah",&eah);

    tupep->GetEntry(ievt);	// get this event

#if 0
    if (TMath::Abs(cosj1) < xCosj && TMath::Abs(cosj2) < xCosj) {
      hNpjp ->Fill(npj1       , 1.);
      hNpjp ->Fill(npj2       , 1.);
    }
    if (npj1 >= xNpj && npj2 >= xNpj) {
      hCosjp->Fill(cosj1      , 1.);
      hCosjp->Fill(cosj2      , 1.);
    }
    if (npj1 >= xNpj && npj2 >= xNpj &&
        TMath::Abs(cosj1) < xCosj && TMath::Abs(cosj2) < xCosj) {
      hEvisp->Fill(evis       , 1.);
      hPtPlp->Fill(pt, pl     , 1.);
      hEtotp->Fill(etk+eem+ehd, 1.);
      hMassp->Fill(mass       , 1.);
    }
#else
      hNpjp ->Fill(npj1       , 1.);
      hNpjp ->Fill(npj2       , 1.);
      hCosjp->Fill(cosj1      , 1.);
      hCosjp->Fill(cosj2      , 1.);
      hEvisp->Fill(evis       , 1.);
      hPtPlp->Fill(pt, pl     , 1.);
      hEtotp->Fill(etk+eem+ehd, 1.);
      hMassp->Fill(mass       , 1.);
#endif
  }
  // ------------------------------------------------------------
  //  Draw histograms
  // ------------------------------------------------------------
  gStyle->SetOptFit(1);
  gStyle->SetOptStat(111111);

  TCanvas *c1p = new TCanvas("c1","",20,20,1220,820);
  TCanvas &c1  = *c1p;
  c1.Divide(3,2);
  Int_t id = 0;

  TPad *cpadp;
  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEvisp->Draw();
  ANLGaussFitter gfit(hEvisp,kNsig);
  gfit.GetFunction()->Draw("same");
  hEvisp->SetFillColor(50);
  hEvisp->SetFillStyle(1000);
  hEvisp->GetXaxis()->SetTitle("E_{vis} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hPtPlp->Draw();
  hPtPlp->SetFillColor(50);
  hPtPlp->SetFillStyle(3001);
  hPtPlp->GetXaxis()->SetTitle("P_{T} [GeV]");
  hPtPlp->GetYaxis()->SetTitle("P_{L} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hNpjp->Draw();
  hNpjp->SetFillColor(50);
  hNpjp->SetFillStyle(3001);
  hNpjp->GetXaxis()->SetTitle("N_{pfos/jet}");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hCosjp->SetMinimum(0.);
  hCosjp->Draw();
  hCosjp->SetFillColor(50);
  hCosjp->SetFillStyle(3000);
  hCosjp->GetXaxis()->SetTitle("cos(#theta_{jet})");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEtotp->Draw();
  ANLGaussFitter gfit(hEtotp,kNsig);
  gfit.GetFunction()->Draw("same");
  hEtotp->SetFillColor(50);
  hEtotp->SetFillStyle(1000);
  hEtotp->GetXaxis()->SetTitle("E_{tot} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hMassp->Draw();
  ANLGaussFitter gfit(hMassp,kNsig);
  gfit.GetFunction()->Draw("same");
  hMassp->SetFillColor(50);
  hMassp->SetFillStyle(1000);
  hMassp->GetXaxis()->SetTitle("M_{Z} [GeV]");

  c1.cd();
}
