//$Id: S4CALTowerGeom.h,v 1.1 2005/08/04 02:51:46 miyamoto Exp $
//*************************************************************
//*
//* --------------
//* S4CALTowerGeom
//* --------------
//*
//* Store CAL geometry data 
//* This object is saved at Initialization of JSFJ4.
//* Re-loaded from ROOT file, when analize data.
//* 
//*(Update Record)
//*  2005/07/29  A.Miyamoto  Original version
//*************************************************************
#ifndef __S4CALTowerGeom__
#define __S4CALTowerGeom__

#include "TObject.h"

class S4CALTowerGeom : public TObject
{
 private:
  Int_t fNCones;     //
  Double_t *fRadius;  //[fNCones]
  Double_t *fTheta;   //[fNCones]
  Double_t *fDTheta;  //[fNCones]
  Int_t    *fNPhi;    //[fNCones]
  
 public:
  S4CALTowerGeom();
  virtual ~S4CALTowerGeom();

  inline Int_t GetNCones(){ return fNCones; }
  inline Double_t GetRadius(Int_t i){ return fRadius[i]; }
  inline Double_t GetTheta(Int_t i){ return fTheta[i]; }
  inline Double_t GetDTheta(Int_t i){ return fDTheta[i]; }
  inline Int_t GetNPhi(Int_t i){ return fNPhi[i]; }

  void LoadJ4CALParameterList();
  void Print();

  ClassDef(S4CALTowerGeom, 1)  // TowerGeometryData

};

#endif
