#ifndef __S4PrimaryVertex__
#define __S4PrimaryVertex__

///////////////////////////////////////////////////////////////////////
//
//  JSFJ4 Parimary Vertex class
//
//$Id: S4PrimaryVertex.h,v 1.1 2005/04/01 11:25:39 fujiik Exp $
//
///////////////////////////////////////////////////////////////////////

#include <TObject.h>
#include <TVector3.h>
#include "S4PrimaryParticle.h"

class G4PrimaryVertex; 
class S4PrimaryVertex;

// *******************************************************
class S4PrimaryVertex : public TObject
{
 protected:
  Int_t               fSerialNo;    // Serial Number of vertex ( 0,1,2... )
  Double_t            fT0;          // Time
  Double_t            fWeight;      // Weight
  TVector3            fPosition;    // Vertex position
  TObjArray          *fParticles;   // Particles belong to this vertex
  S4PrimaryVertex *fNextVertex;  //! next vertex

 public:
  S4PrimaryVertex();
  S4PrimaryVertex(G4PrimaryVertex *p, Int_t ser);
  virtual ~S4PrimaryVertex();

  inline Int_t    GetSerialNo(){ return fSerialNo; }
  inline Double_t GetT0(){ return fT0; }
  inline Double_t GetWeight(){ return fWeight; }
  inline TVector3 GetPosition(){ return fPosition; }
  inline Int_t GetNumberOfParticles(){ return fParticles->GetEntries(); }
  inline TObjArray *GetParticles(){ return fParticles; }
  inline S4PrimaryParticle *GetParticleAt(Int_t i){ 
    return (S4PrimaryParticle*)fParticles->At(i); }
  inline S4PrimaryVertex *GetNextVertex(){ return fNextVertex; }

  inline void Add(S4PrimaryParticle *p){ fParticles->Add(p); }
  inline void Clear(){ fParticles->Clear(); }

  void Print(Option_t *opt="");
  
  ClassDef(S4PrimaryVertex, 1)  // S4PrimaryVertex class

};

#endif










