//*************************************************************************
//* --------------------
//* S4OptDetExactHit
//* --------------------
//* (Description)
//*	OptDetector Hit class.
//*	Mother class : S4VExactHit
//*     
//* (Update Record)
//*	2006/06/05  A.Miyamoto
//*************************************************************************

#include <iostream>

// include "J4OptDetHit.hh"
#include "S4OptDetExactHit.h"
#include "JSFSteer.h"

ClassImp(S4OptDetExactHit)

Int_t S4OptDetExactHit::fOptDetExactHitSortBy = 0; 

//=====================================================================
//* constructor -------------------------------------------------------

S4OptDetExactHit::S4OptDetExactHit()
  : fDetID(0), fDetSerialID(0), fPostPosition(TVector3(0,0,0))
{
}

#if 0
S4OptDetExactHit::S4OptDetExactHit(const J4OptDetHit *hitp)
            : S4VExactHit(hitp->GetHitNumber(),           // hit ID
                          hitp->GetTrackID(),             // track ID
                          hitp->GetMotherTrackID(),       // mother track ID
                          hitp->GetPDGEncoding(),         // particle ID
                          (Int_t)hitp->GetCharge(),       // charge
                          (1.0/cm)*TVector3(hitp->GetPrePosition().x(),
				   hitp->GetPrePosition().y(),
				   hitp->GetPrePosition().z()),
                          hitp->GetTof(),                 // TOF
                          (1.0/GeV)*TVector3(hitp->GetMomentum().x(),
				   hitp->GetMomentum().y(),
				   hitp->GetMomentum().z()),
                          hitp->GetTotalEnergy()   / GeV, // total energy
                          hitp->GetEnergyDeposit() / GeV, // energy deposit
                          0,                              // address ptr
                          0),                             // event ID 
	      fDetID(((J4OptDetHit*)hitp)->GetDetID()),
	      fDetSerialID(((J4OptDetHit*)hitp)->GetDetSerialID()),
	      fPostPosition(((J4OptDetHit*)hitp)->GetPostPosition().x()/cm,
			    ((J4OptDetHit*)hitp)->GetPostPosition().y()/cm,
			    ((J4OptDetHit*)hitp)->GetPostPosition().z()/cm)
{
}
#endif


//=====================================================================
//* destructor --------------------------------------------------------

S4OptDetExactHit::~S4OptDetExactHit()
{
}

//=====================================================================
//* DebugPrint -----------------------------------------------------------

void S4OptDetExactHit::DebugPrint(const Char_t *) 
{

   std::cerr << "------<S4OptDetExactHit::DebugPrint>---------"  << std::endl
	<< " OptDetectorID   = "  << GetDetID()      << std::endl
	<< " OptDetSerialID  = "  << GetDetSerialID() << std::endl
        << " hit ID          = "  << GetHitID()         << std::endl
        << " track ID        = "  << GetTrackID()       << std::endl
        << " mother track ID = "  << GetMotherTrackID() << std::endl
        << " pdg code        = "  << GetPDGCode()       << std::endl
        << " charge          = "  << GetCharge()        << std::endl
        << " position        = (" << GetPosition().X()  << ", "
                                  << GetPosition().Y()  << ", "
                                  << GetPosition().Z()  << ")" 
                                                        << std::endl
        << " momentum        = (" << GetMomentum().X()  << ", " 
                                  << GetMomentum().Y()  << ", " 
                                  << GetMomentum().Z()  << ")" 
                                                        << std::endl
        << " energy          = "  << GetTotalEnergy()   << std::endl
        << " tof             = "  << GetTOF()           << std::endl; 
}

