#ifndef __S4MUDPreHit__
#define __S4MUDPreHit__

//////////////////////////////////////////////////////////////////////
//
//  JSFJ4 MUD PreHit Data
//
//  2004/10/16  Allister Sanchez   Original version.
//
//  $Id: S4MUDPreHit.h,v 1.3 2005/02/27 13:56:24 ono Exp $
/////////////////////////////////////////////////////////////////////

#include "S4VExactHit.h"
#include "S4TPCPostHit.h"
#include <TVector3.h>
#include <TString.h>

class J4MUDPreHit;

// ***************************************************************
class S4MUDPreHit : public S4VExactHit
{
 public:
  S4MUDPreHit();
  S4MUDPreHit(Int_t      postHitID,      // posthit ID
	      Int_t      preHitID,       // prehit ID
	      Int_t      trackID,        // track ID 
	      Int_t      motherTrackID,  // mother track ID
	      Int_t      pcode,          // PDG code
	      Double_t   charge,         // charge
	      TVector3   pos,            // Injection position [cm]
	      Double_t   tof,            // TOF      [nsec]
	      TVector3   mom,            // momentum [GeV] 
	      Double_t   etot,           // energy
	      Double_t   edep,           // energy deposit [GeV]      
	      TVAddress *p = 0);         // address ptr
  S4MUDPreHit(J4MUDPreHit *prehit);
  virtual ~S4MUDPreHit();

  static void   SetSortBy (Char_t *opt="");
         Int_t  Compare   (const TObject*) const;
         Bool_t IsSortable()               const;

  inline Int_t         GetPostHitID     ()  const { return fPostHitID;       }
  inline Int_t         GetPreHitID      ()  const { return GetHitID();       }
  inline Double_t      GetEnergy        ()  const { return GetTotalEnergy(); }
  inline TVector3      GetInjectionPoint()  const { return GetPosition();    }
  inline S4TPCPostHit* GetPostHitPtr()      const { return fPostHitPtr;      }
  inline void          SetPostHitPtr(S4TPCPostHit *p){fPostHitPtr = p; }

  void Print(Option_t *opt="") const;

 private:
  TString       fParticleName;  //  Particle Name
  Int_t         fPostHitID;     //  post hit id
  S4TPCPostHit *fPostHitPtr;    //! post hit ptr

  ClassDef(S4MUDPreHit, 2) // S4MUDPreHit class
};

#endif
