//*************************************************************************
//* --------------------
//* S4ITHitMakerBuf
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/08/22  A.Yamaguchi	Original version.
//*************************************************************************

#include <iostream>
#include "S4ITHitMakerBuf.h"
#include "S4ITExactHit.h"
#include "S4ITHit.h"
using namespace std;

//#define __DEBUG__


ClassImp(S4ITHitMakerBuf)


//=====================================================================
//* constructor -------------------------------------------------------
S4ITHitMakerBuf::S4ITHitMakerBuf(const Char_t  *name,
                                 const Char_t  *title,
                                 S4ITHitMaker *module,
                                 Int_t         bufsize)
               : U4ITHitMakerBuf(name, title, module, bufsize),
                 fInputBufPtr(0)
{
#ifdef __DEBUG__
   cerr << " constructor for S4ITHitMakerBuf is called..." << endl;
#endif
}          
          
S4ITHitMakerBuf::S4ITHitMakerBuf(S4ITHitMaker *module,
                                 const Char_t *name,
                                 const Char_t *title, 
                                 Int_t         bufsize)
               : U4ITHitMakerBuf(module, name, title, bufsize),
                 fInputBufPtr(0)
{
#ifdef __DEBUG__
   cerr << " constructor for S4ITHitMakerBuf is called..." << endl;
#endif
}          

//=====================================================================
//* destructor --------------------------------------------------------

S4ITHitMakerBuf::~S4ITHitMakerBuf()
{
}


//=====================================================================
//* MakeHits ----------------------------------------------------------

void S4ITHitMakerBuf::MakeHits()
{
#ifdef __DEBUG__
   cerr << " S4ITHitMakerBuf::MakeHits() is called..." << endl;
#endif

   if (!fInputBufPtr) {
      cerr << "ERROR  S4ITHitMakerBuf::MakeHits"        << endl
           << "..... cluster data not yet initialized." << endl;
      return;
   }
   else if (IsDone()) return;

   SetDone(kTRUE);

   TIter next(fInputBufPtr);
   S4ITExactHit *exacthitp;
   while ((exacthitp = dynamic_cast<S4ITExactHit *> (next()))) {
      S4ITHit *padhitp = new S4ITHit(exacthitp);
      GetOutputBufPtr()->Add(padhitp);
#ifdef __DEBUG__
      padhitp->DebugPrint();
#endif
   }
}
