#ifndef __S4JET__
#define __S4JET__

//*************************************************************************
//* ---------------------
//* S4Jet Class
//* ---------------------
//* (Description)
//*	represent jet. 
//* (Requires)
//*	S4PFObject
//* (Provides)
//*	S4Jet		: made object class
//* (Update Record)
//*	2004/10/05  S.Yamamoto	Original version.
//*	2004/11/04  K.Fujii	Added Drawable attribute.
//*************************************************************************

#include "ANLJetFinder.h"
#include "TAttDrawable.h"

class S4Jet : public ANLJet, public TAttDrawable {

public:
   S4Jet();
   S4Jet(const ANLJet &jet);
   virtual ~S4Jet();

   virtual void DebugPrint(const Char_t *opt = "") const;

   using TAttDrawable::Draw;
   virtual void Draw(Int_t color, const Char_t *opt = "");

   ClassDef(S4Jet, 1) // jet class
};

#endif
