#ifndef __S4TPCTRACK__
#define __S4TPCTRACK__
//*************************************************************************
//* ---------------------
//* S4TPCTrack Class
//* ---------------------
//* (Description)
//*	Class to store "S4TPCHitCell"s for a single layer.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	S4TPCTrack		: Array containing "S4TPCHitCell"s
//* (Update Record)
//*	2004/09/06  A.Yamaguchi     Original version.
//*************************************************************************

#include "S4TPCTrackMaker.h"
#include "U4TPCTrack.h"
#include "S4VTrack.h"
#include "TAttDrawable.h"

class S4TPCHit;

class S4TPCTrack : public U4TPCTrack, public S4VTrack, public TAttDrawable {
public:
  S4TPCTrack();
  S4TPCTrack(S4TPCTrackMaker *trkm);
  //S4TPCTrack(const S4TPCTrack &tk);
  virtual ~S4TPCTrack();

  virtual void  DebugPrint(const Char_t  *opt = "Brief");
  using TAttDrawable::Draw;
  virtual void   Draw(Int_t color, const Char_t *opt = "");

  virtual Int_t            GetPDGCode();
  virtual Int_t            GetTrackID();
  virtual Int_t            GetMotherTrackID();

  Bool_t Append(S4TPCHit *hitp);
  Bool_t Verify();


  ClassDef(S4TPCTrack, 1)		   // TPC Track
};

#endif
