#ifndef __S4TPCTRACKMAKER__
#define __S4TPCTRACKMAKER__
//*************************************************************************
//* ---------------------
//* S4TPCTrackMaker Class
//* ---------------------
//* (Description)
//*
//* (Requires)
//*	JSFModules:
//* (Provides)
//*	S4TPCTrackMaker		: steering class
//* (Update Record)
//*	2004/08/26 A.Yamaguchi 	Original version.
//*************************************************************************

#include "U4TPCTrackMaker.h"
#include "U4TPCKalDetector.h"

class S4TPCTrackMaker : public U4TPCTrackMaker {
public:
  S4TPCTrackMaker(const Char_t *name  = "S4TPCTrackMaker",
		  const Char_t *title = "TPC Track Maker");
  S4TPCTrackMaker(U4TPCKalDetector *det, 
                  const Char_t     *name  = "S4TPCTrackMaker",
		  const Char_t     *title = "TPC Track Maker");
  virtual ~S4TPCTrackMaker();

  virtual Bool_t Initialize();              // job initialization
  virtual Bool_t BeginRun(Int_t run);       // process Begin Run record
  virtual Bool_t Process(Int_t  ev);        // process event
  
private:

  ClassDef(S4TPCTrackMaker, 1)
};

#endif
