#ifndef __S4VTXTRACKHIT__
#define __S4VTXTRACKHIT__
//*************************************************************************
//* ---------------------
//* S4VTXTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single track hit.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	S4VTXTrackHit		: 
//* (Update Record)
//*	2004/08/26  A.Yamaguchi
//*************************************************************************

#include "S4VTXHit.h"
#include "U4VTXTrackHit.h"


class S4VTXTrackHit : public U4VTXTrackHit {
friend class S4VTXTrack;
public:
  S4VTXTrackHit();
  S4VTXTrackHit(S4VTXHit *ht);
  S4VTXTrackHit(const S4VTXTrackHit &hit);
  virtual ~S4VTXTrackHit();

  static   void   SetSortBy(Char_t *opt = "Time");
  virtual  Int_t  Compare(const TObject *obj) const;

  inline virtual S4VTXHit* GetHitPtr() {
     return  dynamic_cast<S4VTXHit *> (U4VTrackHit::GetHitPtr());
  }
       
private:

  ClassDef(S4VTXTrackHit, 1)       // VTX Hit 
};


#endif
