//
// Read raw data of beam test and converted it to the root file.
// 

int unpack(Int_t run = 0)
{
  gROOT->Reset();

  gSystem->Load("libS4Utils.so");
  gSystem->Load("libU4CDCRawData.so");

  JSFSteer   *jsf    = new JSFSteer();
  
  if (!run) run = jsf->Env()->GetValue("JSFSteer.RunNo",3039);  
  Char_t fname[64];
  // sprintf(fname,"/proj/cdc/data/baby/1998/beam/unpacked/run%4.4d.root",run);
  sprintf(fname,"run%4.4d.root",run);
  // sprintf(fname,"/proj/cdc/data/baby/2000/beam/unpacked/run%4.4d.root",run);
  // sprintf(fname,"/proj/cdc/data/baby/2000/dedx/unpacked/run%4.4d.root",run);
  // sprintf(fname,"/proj/cdc/data/baby/2001/beam/unpacked/run%4.4d.root",run);
  TFile file(fname,"RECREATE");  // Output file
  jsf->SetIOFiles();

#if 0 
// For 98 data
  U4CDCUniversalRecordHeader::UseOldFormat();
#endif
  U4CDCRawData *raw    = new U4CDCRawData();

  Int_t maxevt=jsf->Env()->GetValue("JSFSteer.Nevent",1000);  
  jsf->Initialize();

// Run loop
  jsf->BeginRun(run);     
  for(Int_t ev=1;ev<=maxevt;ev++){
    if( ! jsf->Process(ev) ) break;
    jsf->FillTree();
    jsf->Clear();
  }
  jsf->Terminate();
  file->Write();
}
