//*************************************************************************
//* --------------------
//* U4BabyTrackMaker
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2002/11/15  R.Kuboshima    Original version.
//*************************************************************************

#include "U4BabyTrackMaker.h"
#include "U4BabyTrackMakerBuf.h"
#include "U4CDCHitMakerBuf.h"
#include <iostream>

ClassImp(U4BabyTrackMaker)

//=====================================================================
//* constructor -------------------------------------------------------

U4BabyTrackMaker::U4BabyTrackMaker(const char *name, const char *title)
       			: U4CDCTrackMaker(name,title)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

U4BabyTrackMaker::~U4BabyTrackMaker()
{
}

//=====================================================================
//* Initialize() ------------------------------------------------------

Bool_t U4BabyTrackMaker::Initialize()
{
        std::cerr <<" U4BabyTrackMaker Initialize called" << std::endl;
        fEventBuf = new U4BabyTrackMakerBuf(this);

        return kTRUE;
}

//=====================================================================
//* BeginRun() ------------------------------------------------------

Bool_t U4BabyTrackMaker::BeginRun(Int_t run)
{
        return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t U4BabyTrackMaker::Process(Int_t ev)
{
	U4CDCHitMaker *htmp
	        = (U4CDCHitMaker*)gJSF->FindModule("U4CDCHitMaker");
        U4CDCHitMakerBuf *htbufp = (U4CDCHitMakerBuf *)htmp->EventBuf();

	U4BabyTrackMakerBuf  *tkbufp = (U4BabyTrackMakerBuf *)EventBuf();
	tkbufp->SetInputDataBufPtr(htbufp);
	tkbufp->MakeTracks();
	
        return kTRUE;
}














