#ifndef __U4ITMEASLAYER__
#define __U4ITMEASLAYER__
//*************************************************************************
//* ===================
//*  U4ITMeasLayer Class
//* ===================
//*
//* (Description)
//*   Sample measurement layer class used by U4ITKalHit.
//* (Requires)
//* (Provides)
//*     class U4ITMeasLayer
//* (Update Recored)
//*   2003/09/30  Y.Nakashima       Original version.
//*
//*************************************************************************

#include "TVector3.h"

#include "TKalMatrix.h"
#include "TCylinder.h"
#include "U4VMeasLayer.h"

class TVTrackHit;

class U4ITMeasLayer : public U4VMeasLayer, public TCylinder {
public:

   // Ctors and Dtor

   U4ITMeasLayer(TMaterial &matIn,
                 TMaterial &matOut,
                 Double_t r0,
                 Double_t lhalf,
                 Bool_t   isactive = kTRUE);
   virtual ~U4ITMeasLayer();

   // Parrent's pure virtuals that must be implemented

   virtual TKalMatrix XvToMv    (const TVTrackHit &ht,
                                 const TVector3   &xv) const;
   virtual TKalMatrix XvToMv    (const TVector3   &xv) const;
   virtual TVector3   HitToXv   (const TVTrackHit &ht) const;
   virtual void       CalcDhDa  (const TVTrackHit &ht,
                                 const TVector3   &xv,
                                 const TKalMatrix &dxphiada,
                                       TKalMatrix &H)      const;

private:
   ClassDef(U4ITMeasLayer,1) 	// Sample measurement layer class
};

#endif
