#ifndef __U4ITHITMAKERBUF__
#define __U4ITHITMAKERBUF__
//*************************************************************************
//* ---------------------
//* U4ITHitMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes FADC clusters.
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	U4ITHitMakerBuf		: buffering class
//* (Update Record)
//*	2004/08/07  A.Yamaguchi	Original version.
//*************************************************************************

#include "U4VHitMakerBuf.h"
#include "U4ITHitMaker.h"


class U4ITHitMakerBuf : public U4VHitMakerBuf {

public:
  U4ITHitMakerBuf(const Char_t *name  = "U4ITHitBuf",
	           const Char_t *title = "IT Hit data", 
	           U4ITHitMaker *module = 0, Int_t bufsize = 2000);
  U4ITHitMakerBuf(U4ITHitMaker *module,
	           const Char_t *name  = "U4ITHitBuf",
	           const Char_t *title = "IT Hit data",
	           Int_t bufsize = 2000);
		    
  virtual ~U4ITHitMakerBuf();
  
  virtual void 	DebugPrint(const Char_t *opt = "");
  

protected:
  virtual void	MakeHits() ;	// Make IT Hits
    

  ClassDef(U4ITHitMakerBuf, 1) // Hit data buffer
};



#endif
