#ifndef __U4TPCMEASLAYER__
#define __U4TPCMEASLAYER__
//*************************************************************************
//* ===================
//*  U4TPCMeasLayer Class
//* ===================
//*
//* (Description)
//*   Sample measurement layer class used by U4TPCKalHit.
//* (Requires)
//* (Provides)
//*     class U4TPCMeasLayer
//* (Update Recored)
//*   2003/09/30  Y.Nakashima       Original version.
//*
//*************************************************************************

#include "TVector3.h"
#include "TKalMatrix.h"
#include "TCylinder.h"
#include "U4VMeasLayer.h"

class TVTrackHit;

class U4TPCMeasLayer : public U4VMeasLayer, public TCylinder {
public:

   // Ctors and Dtor

   U4TPCMeasLayer(TMaterial &matIn,
                  TMaterial &matOut,
                  Double_t   r0,
                  Double_t   lhalf,
                  Bool_t     isactive = kTRUE);
   virtual ~U4TPCMeasLayer();

   // Parrent's pure virtuals that must be implemented

   virtual TKalMatrix XvToMv  (const TVTrackHit &ht,
                               const TVector3   &xv)     const;
   virtual TKalMatrix XvToMv  (const TVector3   &xv,
                                     Int_t       side)   const;
   virtual TVector3   HitToXv (const TVTrackHit &ht)     const;
   virtual void       CalcDhDa(const TVTrackHit &ht,
                               const TVector3   &xv,
                               const TKalMatrix &dxphiada,
                                     TKalMatrix &H)      const;

private:

   ClassDef(U4TPCMeasLayer,1) 	// Sample measurement layer class
};

#endif
