//*************************************************************************
//* ---------------------
//* U4TPCTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single Baby hit.
//* (Requires)
//*	TObject
//* (Provides)
//*	U4TPCTrackHit		: 
//* (Update Record)
//*	2004/08/24  A.Yamaguchi
//*************************************************************************

#include "U4TPCTrackHit.h"
#include "U4TPCHit.h"

ClassImp(U4TPCTrackHit)


//=====================================================================
//* constructor -------------------------------------------------------

U4TPCTrackHit::U4TPCTrackHit()
{
}

U4TPCTrackHit::U4TPCTrackHit(U4TPCHit *htp)
             : U4VTrackHit(htp)
{
}
	
U4TPCTrackHit::U4TPCTrackHit(const U4TPCTrackHit &hit)
             : U4VTrackHit(hit) 
{
}

//=====================================================================
//* destructor --------------------------------------------------------

U4TPCTrackHit::~U4TPCTrackHit()
{
}

//=====================================================================
//* SetSortBy --------------------------------------------------------
                                                                                
void U4TPCTrackHit::SetSortBy(Char_t *opt )
{
   switch (opt[2]) {
         case 'd':       // sort by "PadRowNumber"
            default:
               U4VTrackHit::SetSortBy(0);
               break;
   }
}
                                                                                
//=====================================================================
//* IsSoatable --------------------------------------------------------
                                                                                
Bool_t U4TPCTrackHit::IsSortable() const { return kTRUE; }
                                                                                
//=====================================================================
//* Compare -----------------------------------------------------------
Int_t U4TPCTrackHit::Compare(const TObject *obj) const
{
   switch (GetSortBy()) {
      case 0:
      default: {
         Int_t padrowno   = const_cast<U4TPCTrackHit *>(this)
                                        ->GetHitPtr()->GetPadRowNumber();
         Int_t padrownoo  = ((U4TPCTrackHit *)obj)
                                        ->GetHitPtr()->GetPadRowNumber();
         return (padrowno < padrownoo ? -1 : (padrowno > padrownoo ? 1 : 0));
      }
   }
}
